<?php

namespace Makecommerce\Ecommerce\Cron;

use Magento\Framework\Exception\LocalizedException;
use Makecommerce\Ecommerce\Helper\Updater as PaymentUpdater;
use Makecommerce\Ecommerce\Model\Shipping\Locations\Update as LocationUpdater;
use Magento\Framework\App\Cache\Manager as CacheManager;

class Update
{
    /**
     * @var PaymentUpdater
     */
    private $paymentUpdater;

    /**
     * @var LocationUpdater
     */
    private $locationUpdater;

    /**
     * @var CacheManager
     */
    private $cacheManager;

    /**
     * @param PaymentUpdater $paymentUpdater
     * @param LocationUpdater $locationUpdater
     * @param CacheManager $cacheManager
     */
    public function __construct(
        PaymentUpdater $paymentUpdater,
        LocationUpdater $locationUpdater,
        CacheManager $cacheManager
    ){
        $this->paymentUpdater = $paymentUpdater;
        $this->locationUpdater = $locationUpdater;
        $this->cacheManager = $cacheManager;
    }

    /**
     * @return $this
     * @throws LocalizedException
     */
    public function execute()
    {
        $this->paymentUpdater->update(true);
        $this->locationUpdater->update();
        // Flush configuration cache
        $this->cacheManager->clean(['config']);
        return $this;
    }
}
