/*global define,alert*/
define(
    [
        'Magento_Checkout/js/action/set-shipping-information',
        'Magento_Checkout/js/model/step-navigator',
        'Magento_Checkout/js/model/quote',
        'mage/translate'
    ],
    function (
        setShippingInformationAction,
        stepNavigator,
        quote,
        $t
    ) {
        'use strict';

        var mixin = {
            setShippingInformation: function () {
                if (quote.shippingAddress().custom_attributes) {
                    if (quote.shippingAddress().custom_attributes.location_id) {
                        if (quote.shippingAddress().custom_attributes.location_id === '__empty') {
                            alert($t('Please choose a shipping method location!'));
                            return false;
                        }
                    }
                }
                if (this.validateShippingInformation()) {
                    setShippingInformationAction().done(
                        function () {
                            let shippingMethod = quote.shippingMethod().carrier_code + '_' + quote.shippingMethod().method_code;
                            let phone = quote.shippingAddress().telephone;
                            let countryCode = quote.shippingAddress().countryId.substring( 0, 2);
                            switch (shippingMethod) {
                                case 'dpdmc_parcel':
                                case 'smartpostmc_parcel':
                                    if (phone.length < 8 || phone.length > 15) {
                                        alert($t('Phone number must be no shorter than 8 characters and no longer than 15 characters'));
                                        return false;
                                    }
                                    if (phone.substring(0, 1) != '+' && phone.substring(0, 2) != '00') {
                                        alert($t('Phone number must start with internation prefix'));
                                        return false;
                                    }
                                    break;
                                case 'omnivamc_parcel':
                                    switch (countryCode) {
                                        case 'EE':
                                            phone = phone.replace('+372', '');
                                            switch (phone.substring(0, 1)) {
                                                case '5':
                                                    if (phone.length < 7 || phone.length > 8) {
                                                        alert($t('Estonian mobile phone number starting with 5 must be either 7 or 8 digits long'));
                                                        return false;
                                                    }
                                                    break;
                                                case '8':
                                                    if (phone.length != 8) {
                                                        alert($t('Estonian mobile phone number starting with 8 must be 8 digits long'));
                                                        return false;
                                                    }
                                                    break;
                                                default:
                                                    alert($t('Only Estonian mobile phone numbers (number starting with either 5 or 8) are allowed'));
                                                    return false;
                                                    break;
                                            }
                                            if (phone.substring(0, 1) == '5' && (phone.length < 7 || phone.length > 8)) {
                                            }
                                            break;
                                        case 'LV':
                                            phone = phone.replace('+371', '');
                                            if (phone.substring(0, 1) != '2' || phone.length != 8) {
                                                alert($t('Only Latvian mobile phone numbers -- starting with 2 and 8 digits long -- are allowed'));
                                                return false;
                                            }
                                            break;
                                        case 'LT':
                                            phone = phone.replace('+370', '');
                                            if (phone.substring(0, 1) != '6' || phone.length != 8) {
                                                if (phone.substring(0, 2) != '86' || phone.length != 9) {
                                                    alert($t('Only Lithuanian mobile phone number -- starting with 6 and 8 digits long or starting with 86 and 9 digits long -- are allowed'));
                                                    return false;
                                                }
                                            }
                                            break;
                                    }
                                    // Omniva rules
                                    break;
                            }
                            stepNavigator.next();
                        }
                    );
                }
            }
        }

        return function (shipping) {
            return shipping.extend(mixin);
        };
    }
);
